// Code generated by smithy-go-codegen DO NOT EDIT.

package types

import (
	"fmt"
	smithy "github.com/aws/smithy-go"
)

// The owner of the specified snapshot has not authorized your account to access
// the snapshot.
type AccessToSnapshotDeniedFault struct {
	Message *string
}

func (e *AccessToSnapshotDeniedFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *AccessToSnapshotDeniedFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *AccessToSnapshotDeniedFault) ErrorCode() string             { return "AccessToSnapshotDeniedFault" }
func (e *AccessToSnapshotDeniedFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The specified CIDR block or EC2 security group is already authorized for the
// specified cluster security group.
type AuthorizationAlreadyExistsFault struct {
	Message *string
}

func (e *AuthorizationAlreadyExistsFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *AuthorizationAlreadyExistsFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *AuthorizationAlreadyExistsFault) ErrorCode() string {
	return "AuthorizationAlreadyExistsFault"
}
func (e *AuthorizationAlreadyExistsFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The specified CIDR IP range or EC2 security group is not authorized for the
// specified cluster security group.
type AuthorizationNotFoundFault struct {
	Message *string
}

func (e *AuthorizationNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *AuthorizationNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *AuthorizationNotFoundFault) ErrorCode() string             { return "AuthorizationNotFoundFault" }
func (e *AuthorizationNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The authorization quota for the cluster security group has been reached.
type AuthorizationQuotaExceededFault struct {
	Message *string
}

func (e *AuthorizationQuotaExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *AuthorizationQuotaExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *AuthorizationQuotaExceededFault) ErrorCode() string {
	return "AuthorizationQuotaExceededFault"
}
func (e *AuthorizationQuotaExceededFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The maximum number for a batch delete of snapshots has been reached. The limit
// is 100.
type BatchDeleteRequestSizeExceededFault struct {
	Message *string
}

func (e *BatchDeleteRequestSizeExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *BatchDeleteRequestSizeExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *BatchDeleteRequestSizeExceededFault) ErrorCode() string {
	return "BatchDeleteRequestSizeExceededFault"
}
func (e *BatchDeleteRequestSizeExceededFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The maximum number for snapshot identifiers has been reached. The limit is 100.
type BatchModifyClusterSnapshotsLimitExceededFault struct {
	Message *string
}

func (e *BatchModifyClusterSnapshotsLimitExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *BatchModifyClusterSnapshotsLimitExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *BatchModifyClusterSnapshotsLimitExceededFault) ErrorCode() string {
	return "BatchModifyClusterSnapshotsLimitExceededFault"
}
func (e *BatchModifyClusterSnapshotsLimitExceededFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// Could not find the specified S3 bucket.
type BucketNotFoundFault struct {
	Message *string
}

func (e *BucketNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *BucketNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *BucketNotFoundFault) ErrorCode() string             { return "BucketNotFoundFault" }
func (e *BucketNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The account already has a cluster with the given identifier.
type ClusterAlreadyExistsFault struct {
	Message *string
}

func (e *ClusterAlreadyExistsFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ClusterAlreadyExistsFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ClusterAlreadyExistsFault) ErrorCode() string             { return "ClusterAlreadyExistsFault" }
func (e *ClusterAlreadyExistsFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The ClusterIdentifier parameter does not refer to an existing cluster.
type ClusterNotFoundFault struct {
	Message *string
}

func (e *ClusterNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ClusterNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ClusterNotFoundFault) ErrorCode() string             { return "ClusterNotFoundFault" }
func (e *ClusterNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// Cluster is already on the latest database revision.
type ClusterOnLatestRevisionFault struct {
	Message *string
}

func (e *ClusterOnLatestRevisionFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ClusterOnLatestRevisionFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ClusterOnLatestRevisionFault) ErrorCode() string             { return "ClusterOnLatestRevisionFault" }
func (e *ClusterOnLatestRevisionFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// A cluster parameter group with the same name already exists.
type ClusterParameterGroupAlreadyExistsFault struct {
	Message *string
}

func (e *ClusterParameterGroupAlreadyExistsFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ClusterParameterGroupAlreadyExistsFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ClusterParameterGroupAlreadyExistsFault) ErrorCode() string {
	return "ClusterParameterGroupAlreadyExistsFault"
}
func (e *ClusterParameterGroupAlreadyExistsFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The parameter group name does not refer to an existing parameter group.
type ClusterParameterGroupNotFoundFault struct {
	Message *string
}

func (e *ClusterParameterGroupNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ClusterParameterGroupNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ClusterParameterGroupNotFoundFault) ErrorCode() string {
	return "ClusterParameterGroupNotFoundFault"
}
func (e *ClusterParameterGroupNotFoundFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The request would result in the user exceeding the allowed number of cluster
// parameter groups. For information about increasing your quota, go to Limits in
// Amazon Redshift
// (https://docs.aws.amazon.com/redshift/latest/mgmt/amazon-redshift-limits.html)
// in the Amazon Redshift Cluster Management Guide.
type ClusterParameterGroupQuotaExceededFault struct {
	Message *string
}

func (e *ClusterParameterGroupQuotaExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ClusterParameterGroupQuotaExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ClusterParameterGroupQuotaExceededFault) ErrorCode() string {
	return "ClusterParameterGroupQuotaExceededFault"
}
func (e *ClusterParameterGroupQuotaExceededFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The request would exceed the allowed number of cluster instances for this
// account. For information about increasing your quota, go to Limits in Amazon
// Redshift
// (https://docs.aws.amazon.com/redshift/latest/mgmt/amazon-redshift-limits.html)
// in the Amazon Redshift Cluster Management Guide.
type ClusterQuotaExceededFault struct {
	Message *string
}

func (e *ClusterQuotaExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ClusterQuotaExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ClusterQuotaExceededFault) ErrorCode() string             { return "ClusterQuotaExceededFault" }
func (e *ClusterQuotaExceededFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// A cluster security group with the same name already exists.
type ClusterSecurityGroupAlreadyExistsFault struct {
	Message *string
}

func (e *ClusterSecurityGroupAlreadyExistsFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ClusterSecurityGroupAlreadyExistsFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ClusterSecurityGroupAlreadyExistsFault) ErrorCode() string {
	return "ClusterSecurityGroupAlreadyExistsFault"
}
func (e *ClusterSecurityGroupAlreadyExistsFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The cluster security group name does not refer to an existing cluster security
// group.
type ClusterSecurityGroupNotFoundFault struct {
	Message *string
}

func (e *ClusterSecurityGroupNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ClusterSecurityGroupNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ClusterSecurityGroupNotFoundFault) ErrorCode() string {
	return "ClusterSecurityGroupNotFoundFault"
}
func (e *ClusterSecurityGroupNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The request would result in the user exceeding the allowed number of cluster
// security groups. For information about increasing your quota, go to Limits in
// Amazon Redshift
// (https://docs.aws.amazon.com/redshift/latest/mgmt/amazon-redshift-limits.html)
// in the Amazon Redshift Cluster Management Guide.
type ClusterSecurityGroupQuotaExceededFault struct {
	Message *string
}

func (e *ClusterSecurityGroupQuotaExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ClusterSecurityGroupQuotaExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ClusterSecurityGroupQuotaExceededFault) ErrorCode() string {
	return "ClusterSecurityGroupQuotaExceededFault"
}
func (e *ClusterSecurityGroupQuotaExceededFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The value specified as a snapshot identifier is already used by an existing
// snapshot.
type ClusterSnapshotAlreadyExistsFault struct {
	Message *string
}

func (e *ClusterSnapshotAlreadyExistsFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ClusterSnapshotAlreadyExistsFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ClusterSnapshotAlreadyExistsFault) ErrorCode() string {
	return "ClusterSnapshotAlreadyExistsFault"
}
func (e *ClusterSnapshotAlreadyExistsFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The snapshot identifier does not refer to an existing cluster snapshot.
type ClusterSnapshotNotFoundFault struct {
	Message *string
}

func (e *ClusterSnapshotNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ClusterSnapshotNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ClusterSnapshotNotFoundFault) ErrorCode() string             { return "ClusterSnapshotNotFoundFault" }
func (e *ClusterSnapshotNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The request would result in the user exceeding the allowed number of cluster
// snapshots.
type ClusterSnapshotQuotaExceededFault struct {
	Message *string
}

func (e *ClusterSnapshotQuotaExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ClusterSnapshotQuotaExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ClusterSnapshotQuotaExceededFault) ErrorCode() string {
	return "ClusterSnapshotQuotaExceededFault"
}
func (e *ClusterSnapshotQuotaExceededFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// A ClusterSubnetGroupName is already used by an existing cluster subnet group.
type ClusterSubnetGroupAlreadyExistsFault struct {
	Message *string
}

func (e *ClusterSubnetGroupAlreadyExistsFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ClusterSubnetGroupAlreadyExistsFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ClusterSubnetGroupAlreadyExistsFault) ErrorCode() string {
	return "ClusterSubnetGroupAlreadyExistsFault"
}
func (e *ClusterSubnetGroupAlreadyExistsFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The cluster subnet group name does not refer to an existing cluster subnet
// group.
type ClusterSubnetGroupNotFoundFault struct {
	Message *string
}

func (e *ClusterSubnetGroupNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ClusterSubnetGroupNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ClusterSubnetGroupNotFoundFault) ErrorCode() string {
	return "ClusterSubnetGroupNotFoundFault"
}
func (e *ClusterSubnetGroupNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The request would result in user exceeding the allowed number of cluster subnet
// groups. For information about increasing your quota, go to Limits in Amazon
// Redshift
// (https://docs.aws.amazon.com/redshift/latest/mgmt/amazon-redshift-limits.html)
// in the Amazon Redshift Cluster Management Guide.
type ClusterSubnetGroupQuotaExceededFault struct {
	Message *string
}

func (e *ClusterSubnetGroupQuotaExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ClusterSubnetGroupQuotaExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ClusterSubnetGroupQuotaExceededFault) ErrorCode() string {
	return "ClusterSubnetGroupQuotaExceededFault"
}
func (e *ClusterSubnetGroupQuotaExceededFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The request would result in user exceeding the allowed number of subnets in a
// cluster subnet groups. For information about increasing your quota, go to Limits
// in Amazon Redshift
// (https://docs.aws.amazon.com/redshift/latest/mgmt/amazon-redshift-limits.html)
// in the Amazon Redshift Cluster Management Guide.
type ClusterSubnetQuotaExceededFault struct {
	Message *string
}

func (e *ClusterSubnetQuotaExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ClusterSubnetQuotaExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ClusterSubnetQuotaExceededFault) ErrorCode() string {
	return "ClusterSubnetQuotaExceededFault"
}
func (e *ClusterSubnetQuotaExceededFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// Cross-region snapshot copy was temporarily disabled. Try your request again.
type CopyToRegionDisabledFault struct {
	Message *string
}

func (e *CopyToRegionDisabledFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *CopyToRegionDisabledFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *CopyToRegionDisabledFault) ErrorCode() string             { return "CopyToRegionDisabledFault" }
func (e *CopyToRegionDisabledFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The request cannot be completed because a dependent service is throttling
// requests made by Amazon Redshift on your behalf. Wait and retry the request.
type DependentServiceRequestThrottlingFault struct {
	Message *string
}

func (e *DependentServiceRequestThrottlingFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *DependentServiceRequestThrottlingFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *DependentServiceRequestThrottlingFault) ErrorCode() string {
	return "DependentServiceRequestThrottlingFault"
}
func (e *DependentServiceRequestThrottlingFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// Your request cannot be completed because a dependent internal service is
// temporarily unavailable. Wait 30 to 60 seconds and try again.
type DependentServiceUnavailableFault struct {
	Message *string
}

func (e *DependentServiceUnavailableFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *DependentServiceUnavailableFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *DependentServiceUnavailableFault) ErrorCode() string {
	return "DependentServiceUnavailableFault"
}
func (e *DependentServiceUnavailableFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The request would exceed the allowed number of event subscriptions for this
// account. For information about increasing your quota, go to Limits in Amazon
// Redshift
// (https://docs.aws.amazon.com/redshift/latest/mgmt/amazon-redshift-limits.html)
// in the Amazon Redshift Cluster Management Guide.
type EventSubscriptionQuotaExceededFault struct {
	Message *string
}

func (e *EventSubscriptionQuotaExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *EventSubscriptionQuotaExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *EventSubscriptionQuotaExceededFault) ErrorCode() string {
	return "EventSubscriptionQuotaExceededFault"
}
func (e *EventSubscriptionQuotaExceededFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// There is already an existing Amazon Redshift HSM client certificate with the
// specified identifier.
type HsmClientCertificateAlreadyExistsFault struct {
	Message *string
}

func (e *HsmClientCertificateAlreadyExistsFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *HsmClientCertificateAlreadyExistsFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *HsmClientCertificateAlreadyExistsFault) ErrorCode() string {
	return "HsmClientCertificateAlreadyExistsFault"
}
func (e *HsmClientCertificateAlreadyExistsFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// There is no Amazon Redshift HSM client certificate with the specified
// identifier.
type HsmClientCertificateNotFoundFault struct {
	Message *string
}

func (e *HsmClientCertificateNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *HsmClientCertificateNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *HsmClientCertificateNotFoundFault) ErrorCode() string {
	return "HsmClientCertificateNotFoundFault"
}
func (e *HsmClientCertificateNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The quota for HSM client certificates has been reached. For information about
// increasing your quota, go to Limits in Amazon Redshift
// (https://docs.aws.amazon.com/redshift/latest/mgmt/amazon-redshift-limits.html)
// in the Amazon Redshift Cluster Management Guide.
type HsmClientCertificateQuotaExceededFault struct {
	Message *string
}

func (e *HsmClientCertificateQuotaExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *HsmClientCertificateQuotaExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *HsmClientCertificateQuotaExceededFault) ErrorCode() string {
	return "HsmClientCertificateQuotaExceededFault"
}
func (e *HsmClientCertificateQuotaExceededFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// There is already an existing Amazon Redshift HSM configuration with the
// specified identifier.
type HsmConfigurationAlreadyExistsFault struct {
	Message *string
}

func (e *HsmConfigurationAlreadyExistsFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *HsmConfigurationAlreadyExistsFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *HsmConfigurationAlreadyExistsFault) ErrorCode() string {
	return "HsmConfigurationAlreadyExistsFault"
}
func (e *HsmConfigurationAlreadyExistsFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// There is no Amazon Redshift HSM configuration with the specified identifier.
type HsmConfigurationNotFoundFault struct {
	Message *string
}

func (e *HsmConfigurationNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *HsmConfigurationNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *HsmConfigurationNotFoundFault) ErrorCode() string             { return "HsmConfigurationNotFoundFault" }
func (e *HsmConfigurationNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The quota for HSM configurations has been reached. For information about
// increasing your quota, go to Limits in Amazon Redshift
// (https://docs.aws.amazon.com/redshift/latest/mgmt/amazon-redshift-limits.html)
// in the Amazon Redshift Cluster Management Guide.
type HsmConfigurationQuotaExceededFault struct {
	Message *string
}

func (e *HsmConfigurationQuotaExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *HsmConfigurationQuotaExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *HsmConfigurationQuotaExceededFault) ErrorCode() string {
	return "HsmConfigurationQuotaExceededFault"
}
func (e *HsmConfigurationQuotaExceededFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The specified options are incompatible.
type IncompatibleOrderableOptions struct {
	Message *string
}

func (e *IncompatibleOrderableOptions) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *IncompatibleOrderableOptions) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *IncompatibleOrderableOptions) ErrorCode() string             { return "IncompatibleOrderableOptions" }
func (e *IncompatibleOrderableOptions) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// You have exceeded the allowed number of table restore requests. Wait for your
// current table restore requests to complete before making a new request.
type InProgressTableRestoreQuotaExceededFault struct {
	Message *string
}

func (e *InProgressTableRestoreQuotaExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InProgressTableRestoreQuotaExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InProgressTableRestoreQuotaExceededFault) ErrorCode() string {
	return "InProgressTableRestoreQuotaExceededFault"
}
func (e *InProgressTableRestoreQuotaExceededFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The number of nodes specified exceeds the allotted capacity of the cluster.
type InsufficientClusterCapacityFault struct {
	Message *string
}

func (e *InsufficientClusterCapacityFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InsufficientClusterCapacityFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InsufficientClusterCapacityFault) ErrorCode() string {
	return "InsufficientClusterCapacityFault"
}
func (e *InsufficientClusterCapacityFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The cluster does not have read bucket or put object permissions on the S3 bucket
// specified when enabling logging.
type InsufficientS3BucketPolicyFault struct {
	Message *string
}

func (e *InsufficientS3BucketPolicyFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InsufficientS3BucketPolicyFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InsufficientS3BucketPolicyFault) ErrorCode() string {
	return "InsufficientS3BucketPolicyFault"
}
func (e *InsufficientS3BucketPolicyFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The cluster parameter group action can not be completed because another task is
// in progress that involves the parameter group. Wait a few moments and try the
// operation again.
type InvalidClusterParameterGroupStateFault struct {
	Message *string
}

func (e *InvalidClusterParameterGroupStateFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidClusterParameterGroupStateFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidClusterParameterGroupStateFault) ErrorCode() string {
	return "InvalidClusterParameterGroupStateFault"
}
func (e *InvalidClusterParameterGroupStateFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The state of the cluster security group is not available.
type InvalidClusterSecurityGroupStateFault struct {
	Message *string
}

func (e *InvalidClusterSecurityGroupStateFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidClusterSecurityGroupStateFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidClusterSecurityGroupStateFault) ErrorCode() string {
	return "InvalidClusterSecurityGroupStateFault"
}
func (e *InvalidClusterSecurityGroupStateFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The cluster snapshot schedule state is not valid.
type InvalidClusterSnapshotScheduleStateFault struct {
	Message *string
}

func (e *InvalidClusterSnapshotScheduleStateFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidClusterSnapshotScheduleStateFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidClusterSnapshotScheduleStateFault) ErrorCode() string {
	return "InvalidClusterSnapshotScheduleStateFault"
}
func (e *InvalidClusterSnapshotScheduleStateFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The specified cluster snapshot is not in the available state, or other accounts
// are authorized to access the snapshot.
type InvalidClusterSnapshotStateFault struct {
	Message *string
}

func (e *InvalidClusterSnapshotStateFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidClusterSnapshotStateFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidClusterSnapshotStateFault) ErrorCode() string {
	return "InvalidClusterSnapshotStateFault"
}
func (e *InvalidClusterSnapshotStateFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The specified cluster is not in the available state.
type InvalidClusterStateFault struct {
	Message *string
}

func (e *InvalidClusterStateFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidClusterStateFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidClusterStateFault) ErrorCode() string             { return "InvalidClusterStateFault" }
func (e *InvalidClusterStateFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The cluster subnet group cannot be deleted because it is in use.
type InvalidClusterSubnetGroupStateFault struct {
	Message *string
}

func (e *InvalidClusterSubnetGroupStateFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidClusterSubnetGroupStateFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidClusterSubnetGroupStateFault) ErrorCode() string {
	return "InvalidClusterSubnetGroupStateFault"
}
func (e *InvalidClusterSubnetGroupStateFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The state of the subnet is invalid.
type InvalidClusterSubnetStateFault struct {
	Message *string
}

func (e *InvalidClusterSubnetStateFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidClusterSubnetStateFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidClusterSubnetStateFault) ErrorCode() string             { return "InvalidClusterSubnetStateFault" }
func (e *InvalidClusterSubnetStateFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The provided cluster track name is not valid.
type InvalidClusterTrackFault struct {
	Message *string
}

func (e *InvalidClusterTrackFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidClusterTrackFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidClusterTrackFault) ErrorCode() string             { return "InvalidClusterTrackFault" }
func (e *InvalidClusterTrackFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The Elastic IP (EIP) is invalid or cannot be found.
type InvalidElasticIpFault struct {
	Message *string
}

func (e *InvalidElasticIpFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidElasticIpFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidElasticIpFault) ErrorCode() string             { return "InvalidElasticIpFault" }
func (e *InvalidElasticIpFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The specified HSM client certificate is not in the available state, or it is
// still in use by one or more Amazon Redshift clusters.
type InvalidHsmClientCertificateStateFault struct {
	Message *string
}

func (e *InvalidHsmClientCertificateStateFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidHsmClientCertificateStateFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidHsmClientCertificateStateFault) ErrorCode() string {
	return "InvalidHsmClientCertificateStateFault"
}
func (e *InvalidHsmClientCertificateStateFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The specified HSM configuration is not in the available state, or it is still in
// use by one or more Amazon Redshift clusters.
type InvalidHsmConfigurationStateFault struct {
	Message *string
}

func (e *InvalidHsmConfigurationStateFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidHsmConfigurationStateFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidHsmConfigurationStateFault) ErrorCode() string {
	return "InvalidHsmConfigurationStateFault"
}
func (e *InvalidHsmConfigurationStateFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// Indicates that the Reserved Node being exchanged is not in an active state.
type InvalidReservedNodeStateFault struct {
	Message *string
}

func (e *InvalidReservedNodeStateFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidReservedNodeStateFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidReservedNodeStateFault) ErrorCode() string             { return "InvalidReservedNodeStateFault" }
func (e *InvalidReservedNodeStateFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The restore is invalid.
type InvalidRestoreFault struct {
	Message *string
}

func (e *InvalidRestoreFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidRestoreFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidRestoreFault) ErrorCode() string             { return "InvalidRestoreFault" }
func (e *InvalidRestoreFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The retention period specified is either in the past or is not a valid value.
// The value must be either -1 or an integer between 1 and 3,653.
type InvalidRetentionPeriodFault struct {
	Message *string
}

func (e *InvalidRetentionPeriodFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidRetentionPeriodFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidRetentionPeriodFault) ErrorCode() string             { return "InvalidRetentionPeriodFault" }
func (e *InvalidRetentionPeriodFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The S3 bucket name is invalid. For more information about naming rules, go to
// Bucket Restrictions and Limitations
// (https://docs.aws.amazon.com/AmazonS3/latest/dev/BucketRestrictions.html) in the
// Amazon Simple Storage Service (S3) Developer Guide.
type InvalidS3BucketNameFault struct {
	Message *string
}

func (e *InvalidS3BucketNameFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidS3BucketNameFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidS3BucketNameFault) ErrorCode() string             { return "InvalidS3BucketNameFault" }
func (e *InvalidS3BucketNameFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The string specified for the logging S3 key prefix does not comply with the
// documented constraints.
type InvalidS3KeyPrefixFault struct {
	Message *string
}

func (e *InvalidS3KeyPrefixFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidS3KeyPrefixFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidS3KeyPrefixFault) ErrorCode() string             { return "InvalidS3KeyPrefixFault" }
func (e *InvalidS3KeyPrefixFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The scheduled action is not valid.
type InvalidScheduledActionFault struct {
	Message *string
}

func (e *InvalidScheduledActionFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidScheduledActionFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidScheduledActionFault) ErrorCode() string             { return "InvalidScheduledActionFault" }
func (e *InvalidScheduledActionFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The schedule you submitted isn't valid.
type InvalidScheduleFault struct {
	Message *string
}

func (e *InvalidScheduleFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidScheduleFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidScheduleFault) ErrorCode() string             { return "InvalidScheduleFault" }
func (e *InvalidScheduleFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The snapshot copy grant can't be deleted because it is used by one or more
// clusters.
type InvalidSnapshotCopyGrantStateFault struct {
	Message *string
}

func (e *InvalidSnapshotCopyGrantStateFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidSnapshotCopyGrantStateFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidSnapshotCopyGrantStateFault) ErrorCode() string {
	return "InvalidSnapshotCopyGrantStateFault"
}
func (e *InvalidSnapshotCopyGrantStateFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The requested subnet is not valid, or not all of the subnets are in the same
// VPC.
type InvalidSubnet struct {
	Message *string
}

func (e *InvalidSubnet) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidSubnet) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidSubnet) ErrorCode() string             { return "InvalidSubnet" }
func (e *InvalidSubnet) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The subscription request is invalid because it is a duplicate request. This
// subscription request is already in progress.
type InvalidSubscriptionStateFault struct {
	Message *string
}

func (e *InvalidSubscriptionStateFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidSubscriptionStateFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidSubscriptionStateFault) ErrorCode() string             { return "InvalidSubscriptionStateFault" }
func (e *InvalidSubscriptionStateFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The value specified for the sourceDatabaseName, sourceSchemaName, or
// sourceTableName parameter, or a combination of these, doesn't exist in the
// snapshot.
type InvalidTableRestoreArgumentFault struct {
	Message *string
}

func (e *InvalidTableRestoreArgumentFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidTableRestoreArgumentFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidTableRestoreArgumentFault) ErrorCode() string {
	return "InvalidTableRestoreArgumentFault"
}
func (e *InvalidTableRestoreArgumentFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The tag is invalid.
type InvalidTagFault struct {
	Message *string
}

func (e *InvalidTagFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidTagFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidTagFault) ErrorCode() string             { return "InvalidTagFault" }
func (e *InvalidTagFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The usage limit is not valid.
type InvalidUsageLimitFault struct {
	Message *string
}

func (e *InvalidUsageLimitFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidUsageLimitFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidUsageLimitFault) ErrorCode() string             { return "InvalidUsageLimitFault" }
func (e *InvalidUsageLimitFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The cluster subnet group does not cover all Availability Zones.
type InvalidVPCNetworkStateFault struct {
	Message *string
}

func (e *InvalidVPCNetworkStateFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *InvalidVPCNetworkStateFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *InvalidVPCNetworkStateFault) ErrorCode() string             { return "InvalidVPCNetworkStateFault" }
func (e *InvalidVPCNetworkStateFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The encryption key has exceeded its grant limit in AWS KMS.
type LimitExceededFault struct {
	Message *string
}

func (e *LimitExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *LimitExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *LimitExceededFault) ErrorCode() string             { return "LimitExceededFault" }
func (e *LimitExceededFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The operation would exceed the number of nodes allowed for a cluster.
type NumberOfNodesPerClusterLimitExceededFault struct {
	Message *string
}

func (e *NumberOfNodesPerClusterLimitExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *NumberOfNodesPerClusterLimitExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *NumberOfNodesPerClusterLimitExceededFault) ErrorCode() string {
	return "NumberOfNodesPerClusterLimitExceededFault"
}
func (e *NumberOfNodesPerClusterLimitExceededFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The operation would exceed the number of nodes allotted to the account. For
// information about increasing your quota, go to Limits in Amazon Redshift
// (https://docs.aws.amazon.com/redshift/latest/mgmt/amazon-redshift-limits.html)
// in the Amazon Redshift Cluster Management Guide.
type NumberOfNodesQuotaExceededFault struct {
	Message *string
}

func (e *NumberOfNodesQuotaExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *NumberOfNodesQuotaExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *NumberOfNodesQuotaExceededFault) ErrorCode() string {
	return "NumberOfNodesQuotaExceededFault"
}
func (e *NumberOfNodesQuotaExceededFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// User already has a reservation with the given identifier.
type ReservedNodeAlreadyExistsFault struct {
	Message *string
}

func (e *ReservedNodeAlreadyExistsFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ReservedNodeAlreadyExistsFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ReservedNodeAlreadyExistsFault) ErrorCode() string             { return "ReservedNodeAlreadyExistsFault" }
func (e *ReservedNodeAlreadyExistsFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// Indicates that the reserved node has already been exchanged.
type ReservedNodeAlreadyMigratedFault struct {
	Message *string
}

func (e *ReservedNodeAlreadyMigratedFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ReservedNodeAlreadyMigratedFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ReservedNodeAlreadyMigratedFault) ErrorCode() string {
	return "ReservedNodeAlreadyMigratedFault"
}
func (e *ReservedNodeAlreadyMigratedFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The specified reserved compute node not found.
type ReservedNodeNotFoundFault struct {
	Message *string
}

func (e *ReservedNodeNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ReservedNodeNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ReservedNodeNotFoundFault) ErrorCode() string             { return "ReservedNodeNotFoundFault" }
func (e *ReservedNodeNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// Specified offering does not exist.
type ReservedNodeOfferingNotFoundFault struct {
	Message *string
}

func (e *ReservedNodeOfferingNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ReservedNodeOfferingNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ReservedNodeOfferingNotFoundFault) ErrorCode() string {
	return "ReservedNodeOfferingNotFoundFault"
}
func (e *ReservedNodeOfferingNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// Request would exceed the user's compute node quota. For information about
// increasing your quota, go to Limits in Amazon Redshift
// (https://docs.aws.amazon.com/redshift/latest/mgmt/amazon-redshift-limits.html)
// in the Amazon Redshift Cluster Management Guide.
type ReservedNodeQuotaExceededFault struct {
	Message *string
}

func (e *ReservedNodeQuotaExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ReservedNodeQuotaExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ReservedNodeQuotaExceededFault) ErrorCode() string             { return "ReservedNodeQuotaExceededFault" }
func (e *ReservedNodeQuotaExceededFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// A resize operation for the specified cluster is not found.
type ResizeNotFoundFault struct {
	Message *string
}

func (e *ResizeNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ResizeNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ResizeNotFoundFault) ErrorCode() string             { return "ResizeNotFoundFault" }
func (e *ResizeNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The resource could not be found.
type ResourceNotFoundFault struct {
	Message *string
}

func (e *ResourceNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ResourceNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ResourceNotFoundFault) ErrorCode() string             { return "ResourceNotFoundFault" }
func (e *ResourceNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The scheduled action already exists.
type ScheduledActionAlreadyExistsFault struct {
	Message *string
}

func (e *ScheduledActionAlreadyExistsFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ScheduledActionAlreadyExistsFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ScheduledActionAlreadyExistsFault) ErrorCode() string {
	return "ScheduledActionAlreadyExistsFault"
}
func (e *ScheduledActionAlreadyExistsFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The scheduled action cannot be found.
type ScheduledActionNotFoundFault struct {
	Message *string
}

func (e *ScheduledActionNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ScheduledActionNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ScheduledActionNotFoundFault) ErrorCode() string             { return "ScheduledActionNotFoundFault" }
func (e *ScheduledActionNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The quota for scheduled actions exceeded.
type ScheduledActionQuotaExceededFault struct {
	Message *string
}

func (e *ScheduledActionQuotaExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ScheduledActionQuotaExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ScheduledActionQuotaExceededFault) ErrorCode() string {
	return "ScheduledActionQuotaExceededFault"
}
func (e *ScheduledActionQuotaExceededFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The action type specified for a scheduled action is not supported.
type ScheduledActionTypeUnsupportedFault struct {
	Message *string
}

func (e *ScheduledActionTypeUnsupportedFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ScheduledActionTypeUnsupportedFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ScheduledActionTypeUnsupportedFault) ErrorCode() string {
	return "ScheduledActionTypeUnsupportedFault"
}
func (e *ScheduledActionTypeUnsupportedFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The definition you submitted is not supported.
type ScheduleDefinitionTypeUnsupportedFault struct {
	Message *string
}

func (e *ScheduleDefinitionTypeUnsupportedFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *ScheduleDefinitionTypeUnsupportedFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *ScheduleDefinitionTypeUnsupportedFault) ErrorCode() string {
	return "ScheduleDefinitionTypeUnsupportedFault"
}
func (e *ScheduleDefinitionTypeUnsupportedFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The cluster already has cross-region snapshot copy disabled.
type SnapshotCopyAlreadyDisabledFault struct {
	Message *string
}

func (e *SnapshotCopyAlreadyDisabledFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *SnapshotCopyAlreadyDisabledFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *SnapshotCopyAlreadyDisabledFault) ErrorCode() string {
	return "SnapshotCopyAlreadyDisabledFault"
}
func (e *SnapshotCopyAlreadyDisabledFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The cluster already has cross-region snapshot copy enabled.
type SnapshotCopyAlreadyEnabledFault struct {
	Message *string
}

func (e *SnapshotCopyAlreadyEnabledFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *SnapshotCopyAlreadyEnabledFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *SnapshotCopyAlreadyEnabledFault) ErrorCode() string {
	return "SnapshotCopyAlreadyEnabledFault"
}
func (e *SnapshotCopyAlreadyEnabledFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// Cross-region snapshot copy was temporarily disabled. Try your request again.
type SnapshotCopyDisabledFault struct {
	Message *string
}

func (e *SnapshotCopyDisabledFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *SnapshotCopyDisabledFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *SnapshotCopyDisabledFault) ErrorCode() string             { return "SnapshotCopyDisabledFault" }
func (e *SnapshotCopyDisabledFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The snapshot copy grant can't be created because a grant with the same name
// already exists.
type SnapshotCopyGrantAlreadyExistsFault struct {
	Message *string
}

func (e *SnapshotCopyGrantAlreadyExistsFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *SnapshotCopyGrantAlreadyExistsFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *SnapshotCopyGrantAlreadyExistsFault) ErrorCode() string {
	return "SnapshotCopyGrantAlreadyExistsFault"
}
func (e *SnapshotCopyGrantAlreadyExistsFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The specified snapshot copy grant can't be found. Make sure that the name is
// typed correctly and that the grant exists in the destination region.
type SnapshotCopyGrantNotFoundFault struct {
	Message *string
}

func (e *SnapshotCopyGrantNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *SnapshotCopyGrantNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *SnapshotCopyGrantNotFoundFault) ErrorCode() string             { return "SnapshotCopyGrantNotFoundFault" }
func (e *SnapshotCopyGrantNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The AWS account has exceeded the maximum number of snapshot copy grants in this
// region.
type SnapshotCopyGrantQuotaExceededFault struct {
	Message *string
}

func (e *SnapshotCopyGrantQuotaExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *SnapshotCopyGrantQuotaExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *SnapshotCopyGrantQuotaExceededFault) ErrorCode() string {
	return "SnapshotCopyGrantQuotaExceededFault"
}
func (e *SnapshotCopyGrantQuotaExceededFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The specified snapshot schedule already exists.
type SnapshotScheduleAlreadyExistsFault struct {
	Message *string
}

func (e *SnapshotScheduleAlreadyExistsFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *SnapshotScheduleAlreadyExistsFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *SnapshotScheduleAlreadyExistsFault) ErrorCode() string {
	return "SnapshotScheduleAlreadyExistsFault"
}
func (e *SnapshotScheduleAlreadyExistsFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// We could not find the specified snapshot schedule.
type SnapshotScheduleNotFoundFault struct {
	Message *string
}

func (e *SnapshotScheduleNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *SnapshotScheduleNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *SnapshotScheduleNotFoundFault) ErrorCode() string             { return "SnapshotScheduleNotFoundFault" }
func (e *SnapshotScheduleNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// You have exceeded the quota of snapshot schedules.
type SnapshotScheduleQuotaExceededFault struct {
	Message *string
}

func (e *SnapshotScheduleQuotaExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *SnapshotScheduleQuotaExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *SnapshotScheduleQuotaExceededFault) ErrorCode() string {
	return "SnapshotScheduleQuotaExceededFault"
}
func (e *SnapshotScheduleQuotaExceededFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// The specified snapshot schedule is already being updated.
type SnapshotScheduleUpdateInProgressFault struct {
	Message *string
}

func (e *SnapshotScheduleUpdateInProgressFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *SnapshotScheduleUpdateInProgressFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *SnapshotScheduleUpdateInProgressFault) ErrorCode() string {
	return "SnapshotScheduleUpdateInProgressFault"
}
func (e *SnapshotScheduleUpdateInProgressFault) ErrorFault() smithy.ErrorFault {
	return smithy.FaultClient
}

// Amazon SNS has responded that there is a problem with the specified Amazon SNS
// topic.
type SNSInvalidTopicFault struct {
	Message *string
}

func (e *SNSInvalidTopicFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *SNSInvalidTopicFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *SNSInvalidTopicFault) ErrorCode() string             { return "SNSInvalidTopicFault" }
func (e *SNSInvalidTopicFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// You do not have permission to publish to the specified Amazon SNS topic.
type SNSNoAuthorizationFault struct {
	Message *string
}

func (e *SNSNoAuthorizationFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *SNSNoAuthorizationFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *SNSNoAuthorizationFault) ErrorCode() string             { return "SNSNoAuthorizationFault" }
func (e *SNSNoAuthorizationFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// An Amazon SNS topic with the specified Amazon Resource Name (ARN) does not
// exist.
type SNSTopicArnNotFoundFault struct {
	Message *string
}

func (e *SNSTopicArnNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *SNSTopicArnNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *SNSTopicArnNotFoundFault) ErrorCode() string             { return "SNSTopicArnNotFoundFault" }
func (e *SNSTopicArnNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The specified Amazon Redshift event source could not be found.
type SourceNotFoundFault struct {
	Message *string
}

func (e *SourceNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *SourceNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *SourceNotFoundFault) ErrorCode() string             { return "SourceNotFoundFault" }
func (e *SourceNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// A specified subnet is already in use by another cluster.
type SubnetAlreadyInUse struct {
	Message *string
}

func (e *SubnetAlreadyInUse) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *SubnetAlreadyInUse) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *SubnetAlreadyInUse) ErrorCode() string             { return "SubnetAlreadyInUse" }
func (e *SubnetAlreadyInUse) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// There is already an existing event notification subscription with the specified
// name.
type SubscriptionAlreadyExistFault struct {
	Message *string
}

func (e *SubscriptionAlreadyExistFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *SubscriptionAlreadyExistFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *SubscriptionAlreadyExistFault) ErrorCode() string             { return "SubscriptionAlreadyExistFault" }
func (e *SubscriptionAlreadyExistFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The value specified for the event category was not one of the allowed values, or
// it specified a category that does not apply to the specified source type. The
// allowed values are Configuration, Management, Monitoring, and Security.
type SubscriptionCategoryNotFoundFault struct {
	Message *string
}

func (e *SubscriptionCategoryNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *SubscriptionCategoryNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *SubscriptionCategoryNotFoundFault) ErrorCode() string {
	return "SubscriptionCategoryNotFoundFault"
}
func (e *SubscriptionCategoryNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// An Amazon Redshift event with the specified event ID does not exist.
type SubscriptionEventIdNotFoundFault struct {
	Message *string
}

func (e *SubscriptionEventIdNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *SubscriptionEventIdNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *SubscriptionEventIdNotFoundFault) ErrorCode() string {
	return "SubscriptionEventIdNotFoundFault"
}
func (e *SubscriptionEventIdNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// An Amazon Redshift event notification subscription with the specified name does
// not exist.
type SubscriptionNotFoundFault struct {
	Message *string
}

func (e *SubscriptionNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *SubscriptionNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *SubscriptionNotFoundFault) ErrorCode() string             { return "SubscriptionNotFoundFault" }
func (e *SubscriptionNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The value specified for the event severity was not one of the allowed values, or
// it specified a severity that does not apply to the specified source type. The
// allowed values are ERROR and INFO.
type SubscriptionSeverityNotFoundFault struct {
	Message *string
}

func (e *SubscriptionSeverityNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *SubscriptionSeverityNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *SubscriptionSeverityNotFoundFault) ErrorCode() string {
	return "SubscriptionSeverityNotFoundFault"
}
func (e *SubscriptionSeverityNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The number of tables in the cluster exceeds the limit for the requested new
// cluster node type.
type TableLimitExceededFault struct {
	Message *string
}

func (e *TableLimitExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *TableLimitExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *TableLimitExceededFault) ErrorCode() string             { return "TableLimitExceededFault" }
func (e *TableLimitExceededFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The specified TableRestoreRequestId value was not found.
type TableRestoreNotFoundFault struct {
	Message *string
}

func (e *TableRestoreNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *TableRestoreNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *TableRestoreNotFoundFault) ErrorCode() string             { return "TableRestoreNotFoundFault" }
func (e *TableRestoreNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// You have exceeded the number of tags allowed.
type TagLimitExceededFault struct {
	Message *string
}

func (e *TagLimitExceededFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *TagLimitExceededFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *TagLimitExceededFault) ErrorCode() string             { return "TagLimitExceededFault" }
func (e *TagLimitExceededFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// Your account is not authorized to perform the requested operation.
type UnauthorizedOperation struct {
	Message *string
}

func (e *UnauthorizedOperation) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *UnauthorizedOperation) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *UnauthorizedOperation) ErrorCode() string             { return "UnauthorizedOperation" }
func (e *UnauthorizedOperation) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The specified region is incorrect or does not exist.
type UnknownSnapshotCopyRegionFault struct {
	Message *string
}

func (e *UnknownSnapshotCopyRegionFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *UnknownSnapshotCopyRegionFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *UnknownSnapshotCopyRegionFault) ErrorCode() string             { return "UnknownSnapshotCopyRegionFault" }
func (e *UnknownSnapshotCopyRegionFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The requested operation isn't supported.
type UnsupportedOperationFault struct {
	Message *string
}

func (e *UnsupportedOperationFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *UnsupportedOperationFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *UnsupportedOperationFault) ErrorCode() string             { return "UnsupportedOperationFault" }
func (e *UnsupportedOperationFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// A request option was specified that is not supported.
type UnsupportedOptionFault struct {
	Message *string
}

func (e *UnsupportedOptionFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *UnsupportedOptionFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *UnsupportedOptionFault) ErrorCode() string             { return "UnsupportedOptionFault" }
func (e *UnsupportedOptionFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The usage limit already exists.
type UsageLimitAlreadyExistsFault struct {
	Message *string
}

func (e *UsageLimitAlreadyExistsFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *UsageLimitAlreadyExistsFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *UsageLimitAlreadyExistsFault) ErrorCode() string             { return "UsageLimitAlreadyExistsFault" }
func (e *UsageLimitAlreadyExistsFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }

// The usage limit identifier can't be found.
type UsageLimitNotFoundFault struct {
	Message *string
}

func (e *UsageLimitNotFoundFault) Error() string {
	return fmt.Sprintf("%s: %s", e.ErrorCode(), e.ErrorMessage())
}
func (e *UsageLimitNotFoundFault) ErrorMessage() string {
	if e.Message == nil {
		return ""
	}
	return *e.Message
}
func (e *UsageLimitNotFoundFault) ErrorCode() string             { return "UsageLimitNotFoundFault" }
func (e *UsageLimitNotFoundFault) ErrorFault() smithy.ErrorFault { return smithy.FaultClient }
