// Code generated by smithy-go-codegen DO NOT EDIT.

package types

import (
	"time"
)

// The properties (metadata) of a column.
type ColumnMetadata struct {

	// The default value of the column.
	ColumnDefault *string

	// A value that indicates whether the column is case-sensitive.
	IsCaseSensitive bool

	// A value that indicates whether the column contains currency values.
	IsCurrency bool

	// A value that indicates whether an integer column is signed.
	IsSigned bool

	// The label for the column.
	Label *string

	// The length of the column.
	Length int32

	// The name of the column.
	Name *string

	// A value that indicates whether the column is nullable.
	Nullable int32

	// The precision value of a decimal number column.
	Precision int32

	// The scale value of a decimal number column.
	Scale int32

	// The name of the schema that contains the table that includes the column.
	SchemaName *string

	// The name of the table that includes the column.
	TableName *string

	// The database-specific data type of the column.
	TypeName *string
}

// A data value in a column.
//
// The following types satisfy this interface:
//  FieldMemberIsNull
//  FieldMemberBooleanValue
//  FieldMemberLongValue
//  FieldMemberDoubleValue
//  FieldMemberStringValue
//  FieldMemberBlobValue
type Field interface {
	isField()
}

// A value that indicates whether the data is NULL.
type FieldMemberIsNull struct {
	Value bool
}

func (*FieldMemberIsNull) isField() {}

// A value of the Boolean data type.
type FieldMemberBooleanValue struct {
	Value bool
}

func (*FieldMemberBooleanValue) isField() {}

// A value of the long data type.
type FieldMemberLongValue struct {
	Value int64
}

func (*FieldMemberLongValue) isField() {}

// A value of the double data type.
type FieldMemberDoubleValue struct {
	Value float64
}

func (*FieldMemberDoubleValue) isField() {}

// A value of the string data type.
type FieldMemberStringValue struct {
	Value string
}

func (*FieldMemberStringValue) isField() {}

// A value of the BLOB data type.
type FieldMemberBlobValue struct {
	Value []byte
}

func (*FieldMemberBlobValue) isField() {}

// The SQL statement to run.
type StatementData struct {

	// The SQL statement identifier. This value is a universally unique identifier
	// (UUID) generated by Amazon Redshift Data API.
	//
	// This member is required.
	Id *string

	// The date and time (UTC) the statement was created.
	CreatedAt *time.Time

	// The SQL statement.
	QueryString *string

	// The name or Amazon Resource Name (ARN) of the secret that enables access to the
	// database.
	SecretArn *string

	// The name of the SQL statement.
	StatementName *string

	// The status of the SQL statement. An example is the that the SQL statement
	// finished.
	Status StatusString

	// The date and time (UTC) that the statement metadata was last updated.
	UpdatedAt *time.Time
}

// The properties of a table.
type TableMember struct {

	// The name of the table.
	Name *string

	// The schema containing the table.
	Schema *string

	// The type of the table. Possible values include TABLE, VIEW, SYSTEM TABLE, GLOBAL
	// TEMPORARY, LOCAL TEMPORARY, ALIAS, and SYNONYM.
	Type *string
}

// UnknownUnionMember is returned when a union member is returned over the wire,
// but has an unknown tag.
type UnknownUnionMember struct {
	Tag   string
	Value []byte
}

func (*UnknownUnionMember) isField() {}
