// Code generated by smithy-go-codegen DO NOT EDIT.

package types

// Endpoint for mobile app and device.
type Endpoint struct {

	// Attributes for endpoint.
	Attributes map[string]string

	// EndpointArn for mobile app and device.
	EndpointArn *string
}

// The user-specified message attribute value. For string data types, the value
// attribute has the same restrictions on the content as the message body. For more
// information, see Publish
// (https://docs.aws.amazon.com/sns/latest/api/API_Publish.html). Name, type, and
// value must not be empty or null. In addition, the message body should not be
// empty or null. All parts of the message attribute, including name, type, and
// value, are included in the message size restriction, which is currently 256 KB
// (262,144 bytes). For more information, see Amazon SNS message attributes
// (https://docs.aws.amazon.com/sns/latest/dg/SNSMessageAttributes.html) and
// Publishing to a mobile phone
// (https://docs.aws.amazon.com/sns/latest/dg/sms_publish-to-phone.html) in the
// Amazon SNS Developer Guide.
type MessageAttributeValue struct {

	// Amazon SNS supports the following logical data types: String, String.Array,
	// Number, and Binary. For more information, see Message Attribute Data Types
	// (https://docs.aws.amazon.com/sns/latest/dg/SNSMessageAttributes.html#SNSMessageAttributes.DataTypes).
	//
	// This member is required.
	DataType *string

	// Binary type attributes can store any binary data, for example, compressed data,
	// encrypted data, or images.
	BinaryValue []byte

	// Strings are Unicode with UTF8 binary encoding. For a list of code values, see
	// ASCII Printable Characters
	// (https://en.wikipedia.org/wiki/ASCII#ASCII_printable_characters).
	StringValue *string
}

// Platform application object.
type PlatformApplication struct {

	// Attributes for platform application object.
	Attributes map[string]string

	// PlatformApplicationArn for platform application object.
	PlatformApplicationArn *string
}

// A wrapper type for the attributes of an Amazon SNS subscription.
type Subscription struct {

	// The subscription's endpoint (format depends on the protocol).
	Endpoint *string

	// The subscription's owner.
	Owner *string

	// The subscription's protocol.
	Protocol *string

	// The subscription's ARN.
	SubscriptionArn *string

	// The ARN of the subscription's topic.
	TopicArn *string
}

// The list of tags to be added to the specified topic.
type Tag struct {

	// The required key portion of the tag.
	//
	// This member is required.
	Key *string

	// The optional value portion of the tag.
	//
	// This member is required.
	Value *string
}

// A wrapper type for the topic's Amazon Resource Name (ARN). To retrieve a topic's
// attributes, use GetTopicAttributes.
type Topic struct {

	// The topic's ARN.
	TopicArn *string
}
